package org.drools.reproducer;

import org.kie.api.KieServices;
import org.kie.api.builder.KieBuilder;
import org.kie.api.builder.KieFileSystem;
import org.kie.api.builder.KieModule;
import org.kie.api.builder.Message;
import org.kie.api.builder.ReleaseId;
import org.kie.api.builder.model.KieModuleModel;

public class TestBase {

    public static final String KIEBASE = "binding-field-indexed-with-square-brackets";

    public static final String PACKAGE = "org.drools.reproducer";

    protected  KieModule buildKieModule(String version, String rules, boolean executableModel) {
        KieServices ks = KieServices.Factory.get();
        KieFileSystem kfs = ks.newKieFileSystem();

        ReleaseId rid = ks.newReleaseId(PACKAGE, KIEBASE, version);
        kfs.generateAndWritePomXML(rid);

        KieModuleModel kModuleModel = ks.newKieModuleModel();
        kModuleModel.newKieBaseModel(KIEBASE)
                .addPackage(PACKAGE);

        kfs.writeKModuleXML(kModuleModel.toXML());

        kfs.write("src/main/resources/org/drools/reproducer/rules.drl", rules);

        KieBuilder kb = ks.newKieBuilder(kfs);
        if (executableModel) {
            kb.buildAll(org.drools.modelcompiler.ExecutableModelProject.class);
        } else {
            kb.buildAll();
        }

        if (kb.getResults().hasMessages(Message.Level.ERROR)) {
            throw new RuntimeException("Build Errors:\n" + kb.getResults().toString());
        }

        return kb.getKieModule();
    }

}
